#############################################################################
# auto_comments_plugin.tcl Copyright 2005, 2006, 2007, 2008, 2009 r0lZ
# PgcEdit plugin to add some automatic comments in the PGC labels.
#
# This plugin is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This plugin is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#############################################################################
# Usage: copy this file in the <PgcEdit's install dir>/plugins directory.
# An "Auto Comment" menu will be added in the Plugins menu.
# You need PgcEdit 0.6.1 or more to use this plugin.
#############################################################################
# Version History:
#
# v 1.0 (October 2, 2005)
# - First public release
#############################################################################


# Add Plugins -> Auto Comment submenu
if {! [winfo exists .mainmenu.plugins.autocmts]} {
	.mainmenu.plugins add cascade -label "Auto Comment" -menu .mainmenu.plugins.autocmts
	menu .mainmenu.plugins.autocmts
	.mainmenu.plugins.autocmts add command -label "Mark PGC w/o commands as <void>" -command {::plugins::autocmts::comment_void}
	.mainmenu.plugins.autocmts add separator
	.mainmenu.plugins.autocmts add command -label "About" -command {
			tk_messageBox  -title "Auto Comment plugin" -icon info \
					-message "Auto Comment plugin for PgcEdit 0.6.0 or more.\nVersion $::plugins::autocmts::version\nAuthor: r0lZ\nFreeware!"
		}
}


namespace eval ::plugins {}
namespace eval ::plugins::autocmts {

set version "1.0"

# Mark PGCs w/o commands as <void>
proc comment_void {} {
	if {![test_version 0.6.1 "Auto Comment Plugin"]} return
	if {![info exists ::dvddir]} {bell; return}

	for {set vts 0} {$vts <= $::pgcs(numvts)} {incr vts} {
		for {set lu 1} {$lu <= $::menus($vts,numlus)} {incr lu} {
			for {set pgc 1} {$pgc <= $::menus($vts,$lu,numpgcs)} {incr pgc} {
				if {[llength $::menus($vts,$lu,$pgc)] == 3} {
					::utils::add_to_pgc_comment menu $vts $lu $pgc "<void>"
				}
			}
		}
		if {$vts > 0} {
			for {set pgc 1} {$pgc <= $::pgcs($vts,numpgcs)} {incr pgc} {
				if {[llength $::pgcs($vts,$pgc)] == 3} {
					::utils::add_to_pgc_comment pgc $vts 0 $pgc "<void>"
				}
			}
		}
	}
	::main::init_tree_menu_no_move
}



}	;# end of namespace ::plugins::autocmts
